#!usr/bin/env python3

import time
import datetime
import RPi.GPIO as GPIO
import subprocess

import qrcode
import hashlib
import epd2in7b
from PIL import Image
from PIL import ImageFont
from PIL import ImageDraw

from mfrc522 import SimpleMFRC522

import requests as req
import json

def up(channel):
	print ('Button Pressed!')
	global position
	global exe_flag
	if exe_flag == 0:
		position = position + 1
	else:
		position = position
	print (position)

def down(channel):
	print ('Button Pressed')
	global position
	global exe_flag
	if exe_flag == 0:
		position = position - 1
	else:
		position = position
	print (position)

def enter(channel):
	global exe_flag
	if exe_flag == 0:
		exe_flag = 1
	elif exe_flag == 1:
		exe_flag = 2
	else:
		exe_flag = 0

	print ('Exe_flag: ',exe_flag)

def UpdateQR(string):
	qr.clear()
	qr.add_data(string)
	qr.make(fit = True)

	img = qr.make_image()
	img.save('/home/pi/TA/Python/QR.png')

	Image1 = Image.new('1', (epd2in7b.EPD_WIDTH, epd2in7b.EPD_HEIGHT), 255)
	Image2 = Image.new('1', (epd2in7b.EPD_WIDTH, epd2in7b.EPD_HEIGHT), 255)

	newimage = Image.open ('/home/pi/TA/Python/QR.png')
	Image1.paste(newimage, (-15,-15))
	epd.display(epd.getbuffer(Image1), epd.getbuffer(Image2))
	return

epd = epd2in7b.EPD()
reader = SimpleMFRC522()
qr = qrcode.QRCode(
	version = 1,
	error_correction = qrcode.constants.ERROR_CORRECT_L,
	box_size = 5,
	border = 4,
)

ID = []
SubjectID = []
SubjectName = []
Class = []
attendees = []
student = []

GPIO.setmode(GPIO.BOARD)

Execute = 29
UpButton= 31
DownButton = 33

GPIO.setup (Execute, GPIO.IN, pull_up_down=GPIO.PUD_UP)
GPIO.setup (UpButton, GPIO.IN, pull_up_down=GPIO.PUD_UP)
GPIO.setup (DownButton, GPIO.IN, pull_up_down=GPIO.PUD_UP)

GPIO.add_event_detect(UpButton, GPIO.FALLING, callback=up, bouncetime=1000)
GPIO.add_event_detect(DownButton, GPIO.FALLING, callback=down, bouncetime=1000)
GPIO.add_event_detect(Execute, GPIO.FALLING, callback=enter, bouncetime=1000)

position = 0
exe_flag = 0
on = "Online"
off = "Offline"

#ADDRESS TO RASPI SERVER
#OFFLINE ADDRESS
subject_AP_url = "http://192.168.42.1/Subject_AP.php"
participant_AP_url = "http://192.168.42.1/Participant_AP.php"
schedule_AP_url = "http://192.168.42.1/Schedule_AP.php"
student_AP_url = "http://192.168.42.1/Student_AP.php"
insert_AP_url = "http://192.168.42.1/Insert_AP.php"
update_schedule_AP_url = "http://192.168.42.1/update_schedule_AP.php"
#ONLINE ADDRESS
student_retrieve_url = "http://192.168.43.192/student_retrieve.php"
session_retrieve_url = "http://192.168.43.192/session_retrieve.php"
subject_retrieve_url = "http://192.168.43.192/subject_retrieve.php"
participant_retrieve_url = "http://192.168.43.192/participant_retrieve.php"
schedule_retrieve_url = "http://192.168.43.192/schedule_retrieve.php"
import_attendance_url = "http://192.168.43.192/import_attendance.php"
raspi_import_schedule_url = "http://192.168.43.192/raspi_import_schedule.php"

#ADDRESS TO MAIN SERVER
import_student_url = "http://192.168.43.117:8080/TA/import_student.php"
import_session_url = "http://192.168.43.117:8080/TA/import_session.php"
import_subject_url = "http://192.168.43.117:8080/TA/import_subject.php"
import_participant_url = "http://192.168.43.117:8080/TA/import_participant.php"
import_schedule_url = "http://192.168.43.117:8080/TA/import_schedule.php"
attendance_retrieve_url = "http://192.168.43.117:8080/TA/attendance_retrieve.php"
main_schedule_retrieve_url = "http://192.168.43.117:8080/TA/main_schedule_retrieve.php"
subject_url = "http://192.168.43.117:8080/TA/Subject.php"
schedule_url = "http://192.168.43.117:8080/TA/Schedule.php"
participant_url = "http://192.168.43.117:8080/TA/Participant.php"
student_url = "http://192.168.43.117:8080/TA/Student.php"
insert_url = "http://192.168.43.117:8080/TA/Insert.php"
update_schedule_url = "http://192.168.43.117:8080/TA/update_schedule.php"

try:
	epd.init()
	file = open("/home/pi/TA/Python/flag.txt", "rt")
	flag = file.read().split("-")
	file.close()
	print (flag)

	comp_on = any(ele in on for ele in flag)
	comp_off = any(ele in off for ele in flag)

	if (comp_on):
		print ('Please Wait! \n Uploading Data!')
		send1 = req.post(import_student_url)
		print (send1.status_code)
		response1 = json.loads(send1.content)
		print (response1)

		send2 = req.post(student_retrieve_url, json=response1)
		print (send2.status_code)
		print (send2.content)
		time.sleep(1)

		send3 = req.post(import_session_url)
		print (send3.status_code)
		response2 = json.loads(send3.content)
		print (response2)

		send4 = req.post(session_retrieve_url, json=response2)
		print (send4.status_code)
		print (send4.content)

		send5 = req.post(import_subject_url)
		print (send5.status_code)
		response3 = json.loads(send5.content)
		print (response3)

		send6 = req.post(subject_retrieve_url, json=response3)
		print (send6.status_code)
		print (send6.content)

		send7 = req.post(import_participant_url)
		print (send7.status_code)
		response4 = json.loads(send7.content)
		print (response4)

		send8 = req.post(participant_retrieve_url, json=response4)
		print (send8.status_code)
		print (send8.content)

		send18 = req.post(raspi_import_schedule_url)
		print (send18.status_code)
		response12 = json.loads(send18.content)
		print (response12)

		send19 = req.post(main_schedule_retrieve_url, json=response12)
		print (send19.status_code)
		print (send19.content)

		send11 = req.post(import_attendance_url)
		print (send11.status_code)
		response6 = json.loads(send11.content)
		print (response6)

		send12 = req.post(attendance_retrieve_url, json=response6)
		print (send12.status_code)
		print (send12.content)

		print ('Data Transaction Process Completed!')
		print ('Starting Attendance Process!')

		send13 = req.post(subject_url)
		print (send13.status_code)
		response7 = json.loads(send13.content)
		print (response7)
		ID = response7["ID"]
		SubjectID = response7["SubjectID"]
		SubjectName = response7["SubjectName"]
		Class = response7["Class"]

		while True:
			while exe_flag == 0:
				print (ID[position])
				print (SubjectID[position])
				print (SubjectName[position])
				print (Class[position])

				attendees = []
				print (attendees)
				time.sleep(1)

			while exe_flag == 1:
				if (len(attendees) == 0):
					now = datetime.datetime.now()
					ScheduleDate = str(now.strftime("%Y-%m-%d"))
					ScheduleTime = str(now.strftime("%H:%M:%S"))
					SubjectData = {"ID":ID[position]}
					ScheduleData = {"ID":ID[position], "DateIn":ScheduleDate, "TimeIn":ScheduleTime}
					print (SubjectData)
					print (ScheduleData)

					send14 = req.post(participant_url, json=SubjectData)
					print (send14.status_code)
					response8 = json.loads(send14.content)
					print (response8)
					attendees = response8["NRP"]

					send15 = req.post(schedule_url, json=ScheduleData)
					print(send15.status_code)
					response9 = json.loads(send15.content)
					print (response9)
					NumberOfAttendance = response9["NumberOfAttendance"]
					ScheduleID = response9["ScheduleID"]

					hash_string = ID[position] + ',' + str(now.strftime("%Y-%m-%d"))
					hash = hashlib.md5(hash_string.encode())
					hash_result = hash.hexdigest()
					print (hash_string)
					print (hash_result)

					QRData = ID[position] + ',' + str(now.strftime("%Y-%m-%d")) + ',' + str(now.strftime("%H:%M:%S")) + ',' + str(ScheduleID) + ',' + hash_result
					print (QRData)
					UpdateQR(QRData)

					print (ID[position])
					print (attendees)

				id,text = reader.read()
				StudentTag = {"TAG_ID":str(id)}
				print (StudentTag)

				send16 = req.post(student_url, json=StudentTag)
				print (send16.status_code)
				response10 = json.loads(send16.content)
				NRP = response10["NRP"]
				print (NRP)

				comp_participant = any(ele in NRP for ele in attendees)

				if (comp_participant):
					now = datetime.datetime.now()
					attendance_time = str(now.strftime("%Y-%m-%d %H:%M:%S"))
					print (attendance_time)
					AttendanceData = {"NRP":NRP, "ScheduleID":ScheduleID, "TimeIn":attendance_time}
					print (AttendanceData)

					send17 = req.post(insert_url, json=AttendanceData)
					print (send17.status_code)
					response11 = json.loads(send17.content)
					print (response11)
					insert_status = response11["success"]
					insert_message = response11["Message"]

					if (insert_status):
						print ('Attendance Checked!')
						print (insert_message)
					else:
						print ('Error!')
						print (insert_message)
				else:
					print ('Student not listed!')

				time.sleep(1)

			while exe_flag == 2:
				now = datetime.datetime.now()
				update_data = {"ScheduleID":ScheduleID, "TimeOut":str(now.strftime("%H:%M:%S"))}
				print (update_data)
				send25 = req.post(update_schedule_url, json=update_data)
				print (send25.status_code)
				print (send25.content)

				send9 = req.post(import_schedule_url)
				print (send9.status_code)
				response5 = json.loads(send9.content)
				print (response5)

				send10 = req.post(schedule_retrieve_url, json=response5)
				print (send10.status_code)
				print (send10.content)

				send3 = req.post(import_session_url)
				print (send3.status_code)
				response2 = json.loads(send3.content)
				print (response2)

				send4 = req.post(session_retrieve_url, json=response2)
				print (send4.status_code)
				print (send4.content)


				file = open("/home/pi/TA/Python/flag.txt", "w")
				file.write("1")
				file.close()
				print ('Flag.txt Overwritten!')
				time.sleep(1)
				epd.Clear()
				epd.sleep()
				print ("EPD Cleared!")
				time.sleep(1)
				GPIO.cleanup()
				#subprocess.Popen.terminate()
				quit()

	else:
		print ('Running Offline Mode!')
		send20 = req.post(subject_AP_url)
		print (send20.status_code)
		response13 = json.loads(send20.content)
		print (response13)
		ID = response13["ID"]
		SubjectID = response13["SubjectID"]
		SubjectName = response13["SubjectName"]
		Class = response13["Class"]

		while True:
			while exe_flag == 0:
				print (ID[position])
				print (SubjectID[position])
				print (SubjectName[position])
				print (Class[position])
			
				attendees = []
				print (attendees)
				time.sleep(1)

			while exe_flag == 1:
				if (len(attendees) == 0):
					now = datetime.datetime.now()
					ScheduleDate = str(now.strftime("%Y-%m-%d"))
					ScheduleTime = str(now.strftime("%H:%M:%S"))
					SubjectData = {"ID":ID[position]}
					ScheduleData = {"ID":ID[position], "DateIn":ScheduleDate, "TimeIn":ScheduleTime}
					print (SubjectData)
					print (ScheduleData)
					
					send21 = req.post(participant_AP_url, json=SubjectData)
					print (send21.status_code)
					response14 = json.loads(send21.content)
					print (response14)
					attendees = response14["NRP"]
					
					send22 = req.post(schedule_AP_url, json=ScheduleData)
					print (send22.status_code)
					response15 = json.loads(send22.content)
					print (response15)
					NumberOfAttendance = response15["NumberOfAttendance"]
					ScheduleID = response15["ScheduleID"]
					
					hash_string = ID[position] + ',' + str(now.strftime("%Y-%m-%d"))
					hash = hashlib.md5(hash_string.encode())
					hash_result = hash.hexdigest()
					print (hash_string)
					print (hash_result)

					QRData = ID[position] + ',' + str(now.strftime("%Y-%m-%d")) + ',' + str(now.strftime("%H:%M:%S")) + ',' + str(ScheduleID) + ',' + hash_result
					print (QRData)
					UpdateQR(QRData)
					
					print (ID[position])
					print (attendees)

				id,text = reader.read()
				StudentTag = {"TAG_ID":str(id)}
				print (StudentTag)
				
				send23 = req.post(student_AP_url, json=StudentTag)
				print (send23.status_code)
				response16 = json.loads(send23.content)
				NRP = response16["NRP"]
				print (NRP)
				
				comp_participant = any(ele in NRP for ele in attendees)
				
				if (comp_participant):
					now = datetime.datetime.now()
					attendance_time = str(now.strftime("%Y-%m-%d %H:%M:%S"))
					print (attendance_time)
					AttendanceData = {"NRP":NRP, "ScheduleID":ScheduleID, "TimeIn":attendance_time}
					print (AttendanceData)
					
					send24 = req.post(insert_AP_url, json=AttendanceData)
					print (send24.status_code)
					response17 = json.loads(send24.content)
					print (response17)
					insert_status = response17["success"]
					insert_message = response17["Message"]

					if (insert_status):
						print ('Attendance Checked!')
						print (insert_message)
					else:
						print ('Error!')
						print (insert_message)
				
				else:
					print ('Student not listed!')

				time.sleep(1)
			
			while exe_flag == 2:
				now = datetime.datetime.now()
				update_data = {"ScheduleID":ScheduleID, "TimeOut":str(now.strftime("%H:%M:%S"))}
				print (update_data)
				send26 = req.post(update_schedule_AP_url, json=update_data)
				print (send26.status_code)
				print (send26.content)

				file = open("/home/pi/TA/Python/flag.txt", "w")
				file.write("1")
				file.close()
				print ('Flag.txt Overwritten!')
				time.sleep(1)
				epd.Clear()
				epd.sleep()
				print ("EPD Cleared!")
				time.sleep(1)
				#subprocess.Popen.terminate()
				GPIO.cleanup()
				quit()

except KeyboardInterrupt:
	#file = open("/home/pi/TA/Python/flag.txt", "w")
	#file.write("1")
	#file.close()
	epd.sleep()
	GPIO.cleanup()
